var React = require('react');
var _ = require('lodash');

var ItemForm = React.createClass({

  getInitialState: function() {
    return {
      label: '',
      icon: '',
      exec: '',
      import: '',
      background: ''
    };
  },

  componentWillReceiveProps: function(props) {

    if(props.item) {

      this.setState({
        label: props.item.label,
        icon: props.item.icon,
        exec: props.item.exec,
        background: props.item.background,
        import: props.item.import
      });
    }

  },

  render: function() {

    var state = this.state;

    return (
      <div className="item-form">
        <form>
          <div className="form-group">
            <input type="text" className="form-control"
              placeholder="Label"
              value={state.label}
              onChange={this.handleChange.bind(this, 'label')} />
          </div>
          <div className="form-group">
            <input type="text" className="form-control"
              placeholder="Icône"
              value={state.icon}
              onChange={this.handleChange.bind(this, 'icon')} />
          </div>
          <div className="form-group">
            <input type="text" className="form-control"
              placeholder="Chemin d'exécution" value={state.exec}
              onChange={this.handleChange.bind(this, 'exec')} />
          </div>
          <div className="form-group">
            <input type="text" className="form-control"
              placeholder="Fond d'écran" value={state.background}
              onChange={this.handleChange.bind(this, 'background')} />
          </div>
          <div className="form-group">
            <input type="text" className="form-control"
              placeholder="Import" value={state.import}
              onChange={this.handleChange.bind(this, 'import')} />
          </div>
        </form>
      </div>
    );

  },

  handleChange: function(key, evt) {

    evt.preventDefault();

    var newState = {};
    var value = evt.currentTarget.value;

    newState[key] = value;
    this.setState(newState);

    if(typeof this.props.onItemChange === 'function') {
      this.props.onItemChange(this.props.item, key, value);
    }

  }

});

module.exports = ItemForm;
